package koverja;

import java.util.Random;
import sortieren.*;

/**
 * @version 0.1
 * @author Martin Andreas Filusch
 */
public class Test
{

  private boolean bubblesort = true;
  private boolean selectionsort = true;
  private boolean mergesort = true;
  private boolean quicksort = true;
  private boolean heapsort = true;
  private int[] folge;
  private Random random = new Random();

  public Test()
  {
    folge = new int[10000];
    for ( int i = 0; i < 10000; i++ ) {
      folge[i] = random.nextInt();
    }
  }

//  public Test(int laenge)
//  {
//    folge = new int[laenge];
//    for ( int i = 0; i < laenge; i++ ) {
//      folge[i] = random.nextInt();
//    }
//  }

  public long[] doTest()
  {
    long[] ergebnis = {0L, 0L, 0L, 0L, 0L};
    long startzeit, endzeit;
    if ( bubblesort ) {
      startzeit = System.currentTimeMillis();
      BubbleSort.sort(getFolge().clone());
      endzeit = System.currentTimeMillis();
      ergebnis[0] = endzeit - startzeit;
    }
    if ( selectionsort ) {
      startzeit = System.currentTimeMillis();
      SelectionSort.sort(getFolge().clone());
      endzeit = System.currentTimeMillis();
      ergebnis[1] = endzeit - startzeit;
    }
    if ( mergesort ) {
      startzeit = System.currentTimeMillis();
      MergeSort.sort(getFolge().clone());
      endzeit = System.currentTimeMillis();
      ergebnis[2] = endzeit - startzeit;
    }
    if ( quicksort ) {
      startzeit = System.currentTimeMillis();
      QuickSort.sort(getFolge().clone());
      endzeit = System.currentTimeMillis();
      ergebnis[3] = endzeit - startzeit;
    }
    if ( heapsort ) {
      startzeit = System.currentTimeMillis();
      HeapSort.sort(getFolge().clone());
      endzeit = System.currentTimeMillis();
      ergebnis[4] = endzeit - startzeit;
    }
    return ergebnis;
  }

  /**
   * @return the bubblesort
   */
  public boolean isBubblesort()
  {
    return bubblesort;
  }

  /**
   * @param bubblesort the bubblesort to set
   */
  public void setBubblesort(boolean bubblesort)
  {
    this.bubblesort = bubblesort;
  }

  /**
   * @return the selectionsort
   */
  public boolean isSelectionsort()
  {
    return selectionsort;
  }

  /**
   * @param selectionsort the selectionsort to set
   */
  public void setSelectionsort(boolean selectionsort)
  {
    this.selectionsort = selectionsort;
  }

  /**
   * @return the mergesort
   */
  public boolean isMergesort()
  {
    return mergesort;
  }

  /**
   * @param mergesort the mergesort to set
   */
  public void setMergesort(boolean mergesort)
  {
    this.mergesort = mergesort;
  }

  /**
   * @return the quicksort
   */
  public boolean isQuicksort()
  {
    return quicksort;
  }

  /**
   * @param quicksort the quicksort to set
   */
  public void setQuicksort(boolean quicksort)
  {
    this.quicksort = quicksort;
  }

  /**
   * @return the heapsort
   */
  public boolean isHeapsort()
  {
    return heapsort;
  }

  /**
   * @param heapsort the heapsort to set
   */
  public void setHeapsort(boolean heapsort)
  {
    this.heapsort = heapsort;
  }

  /**
   * @return the folge
   */
  public int[] getFolge()
  {
    return folge;
  }

  /**
   * @param folge the folge to set
   */
  public void setFolge(int[] folge)
  {
    this.folge = folge;
  }
}
