package koverja.util;

import AlgoTools.IO;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Random;

/**
 * @version 0.1
 * @author Martin Andreas Filusch
 */
public class Folge
{

  private static Random random = new Random();

  public static boolean speichern(int[] folge, String dateiname)
  {
    try {
      ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(dateiname + ".folge"));
      oos.writeObject(folge);
      oos.close();
      return true;
    } catch (Exception exception) {
      exception.printStackTrace();
    }
    return false;
  }

  public static int[] laden(String dateiname)
  {
    try {
      int[] folge;
      ObjectInputStream ois = new ObjectInputStream(new FileInputStream(dateiname));
      folge = (int[]) ois.readObject(); 
      return folge;
    } catch (Exception exception) {
      exception.printStackTrace();
    }
    return null;
  }

  public static int[] generieren(int laenge, Sortiert sortiert)
  {
    switch (sortiert) {
      case SORTIERT:
        return generierSortiert(laenge);
      case VERKEHRT:
        return generierVerkehrt(laenge);
      case ZUFALL:
        return generierZufall(laenge);
      default:
        return null;
    }
  }

  private static int[] generierSortiert(int laenge)
  {
    int[] folge = new int[laenge];
    for ( int i = 0; i < laenge; i++ ) {
      folge[i] = i;
    }
    return folge;
  }

  private static int[] generierVerkehrt(int laenge)
  {
    int[] folge = new int[laenge];
    for ( int i = 0; i < laenge; i++ ) {
      folge[i] = laenge - i;
    }
    return folge;
  }

  private static int[] generierZufall(int laenge)
  {
    int[] folge = new int[laenge];
    for ( int i = 0; i < laenge; i++ ) {
      folge[i] = random.nextInt();
    }
    return folge;
  }
}
